program test_write_overlap

  use, intrinsic:: ISO_FORTRAN_ENV

  ! Libraries:
  use jumble, only: new_unit

  use derived_types, only: shp_tr
  use shp_tr_close_m, only: shp_tr_close
  use shp_tr_create_m, only: shp_tr_create
  use write_overlap_m, only: write_overlap, init_interpolated_eddy

  implicit none

  integer unit_edgelist, j_interp
  integer:: k = 2, delta = 1, m = 0
  real:: coord_extr_1(2) = [0., 0.], coord_extr_2(2) = [0., 0.] ! in rad
  real:: ssh_extr_1 = 0., ssh_extr_2 = 0.
  TYPE(shp_tr) hshp
  namelist /main_nml/ k, delta, m, coord_extr_1, ssh_extr_1, coord_extr_2, &
       ssh_extr_2

  !-------------------------------------------------------------------------

  write(unit = error_unit, nml = main_nml)
  write(unit = error_unit, fmt = *) "Enter namelist main_nml."
  read(unit = *, nml = main_nml)
  write(unit = *, nml = main_nml)
  
  call new_unit(unit_edgelist)
  open(unit_edgelist, file = "edgelist.csv", status = "replace", &
       action  = "write")

  ! Title lines:
  write(unit_edgelist, fmt = "(1x, a)") '"predecessor date subscript" ' &
       // '"predecessor eddy subscript" "successor date subscript" ' &
       // '"successor eddy subscript"'
  write(unit_edgelist, fmt = *) "k1 i1 k2 i2 weight"
  
  call shp_tr_create(hshp, shp_tr_dir = "SHP_triplet")
  call init_interpolated_eddy
  call write_overlap(hshp, unit_edgelist, k, delta, i1 = 1, i2 = 2, m = m, &
       i_interp = 10 + [(j_interp, j_interp = 1, delta - 1)], &
       cyclone = .true., coord_extr_1 = coord_extr_1, ssh_extr_1 = ssh_extr_1, &
       coord_extr_2 = coord_extr_2, ssh_extr_2 = ssh_extr_2, w = 0.)
  close(unit_edgelist)
  print *, 'Created file "edgelist.csv".'
  CALL shp_tr_close(hshp)
  print *, 'Created shapefiles in SHP_triplet.'

end program test_write_overlap
